<?php // queryform.php: chok(tue 9 jul 2002)

require_once('handle_vars.php');
vars_save();

require_once('draw.php');
?>



<html>
<head>
<title>Data Query Form</title>
<link rel="stylesheet" href="style.css">

<script language=Javascript>

var all_cols = new Array('IP','Hostname','OS','Active','Total','PercentActive',
	'DateInserted','LastActive','LastModified','DaysOffline');
var default_cols = new Array('IP', 'Hostname', 'PercentActive', 'DateInserted',
	'LastActive', 'DaysOffline');

function check_show_all_columns()
// uncheck all the other columns
{
	var box = document.dbform.show_all_columns;
	if(! box.checked) {
		// check all default columns
		for( i=0, any_checked=false, len=default_cols.length; i<len; i++ )
			eval('document.dbform.show_' + default_cols[i] + '.checked = true');
		window.status = 'Checked the default columns to display';
		return;
	}

	// uncheck all other columns
	var i, len;
	for( i=0, len=all_cols.length; i<len; i++ )
		eval('document.dbform.show_' + all_cols[i] + '.checked = false');
	window.status = 'Unchecked all other columns to show all columns';
}

function uncheck_show_all_columns()
// uncheck the "Show all columns" checkbox
{
	var box = document.dbform.show_all_columns;

	box.checked = false;

	// check that if no boxes are checked, then check "Show all columns"
	var i, len;
	for( i=0, any_checked=false, len=all_cols.length; i<len; i++ )
		eval('any_checked |= document.dbform.show_' + all_cols[i] + '.checked');
	if(! any_checked) {
		box.checked = true;
		window.status = 'Checked the "Show all columns" box to display all columns';
	}
}

</script>

</head>

<body>





<?php

function head($s)
{
	return '<font face=Arial size=2 color=#7777ff><b><u>' .
		$s . '</u></b></font><br>';
}

$font = '<font name=Arial size=2 color=#666666>';

?>



<?php

draw_title('Data Query Form', 0, // 0 - don't show additional stuff
	'home.php', 'Back to Home Page');

require_once('handle_vars.php');
vars_save();

?>





<form name=dbform action="queryform_save.php" method=get>
<input type=hidden name=start_row value=0>


<table>
<tr>
	<td width=30 nowrap>&nbsp;</td>
	<td valign=top nowrap>

		<br>


		<!................................................................>

		<?=head('Select a Subnet');?>

		<?=$font;?>
		Choose a subnet to display:

		<table cellspacing=0 cellpadding=0>
		<tr>
			<td nowrap valign=center>&nbsp; <img src="images/tinybluebullet.gif"> &nbsp;</td>
			<td nowrap valign=center>
				<?php
				// obtain all subnets from the database
				require_once('db.php');
				$aa = db_col("select IP from iptable order by LongIP");
				$all_subnets = array();
				$index = 0;
				foreach($aa as $ip):
					// get the subnet
					if(! ereg("([0-9]+\\.[0-9]+\\.[0-9]+\\.)[0-9]+", $ip, $regs))
						print("found invalid IP $ip in iptable");

					if( $index==0 || strcmp($all_subnets[$index-1],$regs[1]) )
						$all_subnets[$index++] = $regs[1];
				endforeach;
				?>

				<select class=textbox name=subnet_ip_regex><option value="">All subnets
				<?php
				// print out all <option>'s
				foreach($all_subnets as $s):
					$t = $s . '*';
					print('<option');
					if( strcmp($subnet_ip_regex,$t)==0 ) print(' selected');
					print(">$t");
				endforeach;
				?>
				</select>
			</td>
		</tr>
		</table>


		<!................................................................>

		<br><?=head('Specify IP Addresses');?>

		<?=$font;?>
		Enter a regular expression e.g.<br>
		"130.207.226.*" (no quotes), or to get<br>
		a single IP, just enter that IP address:<br>

		<table cellspacing=0 cellpadding=0>
		<tr>
			<td nowrap valign=center>&nbsp; <img src="images/tinybluebullet.gif"> &nbsp;</td>
			<td nowrap valign=center>
				<input class=textbox type=text name="ip_regex" size=23 value="<?=$ip_regex;?>">
			</td>
		</tr>
		<tr>
			<td></td>
			<td>
				(Leave empty to show all IPs)
			</td>
		</tr>
		</table>



		<!................................................................>

		<br>

		<?=head('Include DNS Comparison');?>

		<?=$font;?>
		<input type=checkbox name="include_dns" <?=($include_dns?'checked':'');?>>
		Show DNS comparison data

		<br>

		<input type=checkbox name="include_dns_only" <?=($include_dns_only?'checked':'');?>>
		Show DNS comparison data only


		<!................................................................>

		<br><br>
		<?=head('Number of Days Off-line');?>

		<?=$font;?>
		Enter the <b>minimum</b> number of days<br>
		the host(s) have been off-line:<br>

		<table cellspacing=0 cellpadding=0>
		<tr>
			<td nowrap valign=center>&nbsp; <img src="images/tinybluebullet.gif"> &nbsp;</td>
			<td nowrap valign=center>
				<input class=textbox type=text name="min_DaysOffline" size=23 value="<?=$min_DaysOffline;?>">
			</td>
		</tr>
		</table>

		<br>
		<br>

	</td>

	<td width=20 nowrap style="border-right:solid 1px #dddddd;">&nbsp;</td>
	<td width=20 nowrap>&nbsp;</td>

	<td valign=top nowrap>

		<br>

		<!................................................................>

		&nbsp;<?=head('Duplicate Hostnames');?>

		<table>
		<tr>
			<td valign=top><input type=checkbox name=duphosts_only
				value=1 <?=strlen($duphosts_only)?'checked':'';?>>
			</td>
			<td nowrap valign=top><?=$font;?>Display duplicated <br> hostnames only</td>
		</tr>
		</table>


		<!................................................................>

		<br>&nbsp;<?=head('Operating System');?>

		<?php $a=array($os_group => 'checked '); ?>

		<table>
		<tr>
			<td valign=top><input type="radio" value="" <?=$a[''];?>name="os_group"></td>
			<td valign=top><?=$font;?>Display all systems</td>
		</tr>
		<tr>
			<td valign=top><input type="radio" value="win" <?=$a['win'];?>name="os_group"></td>
			<td valign=top><?=$font;?>MS Windows systems</td>
		</tr>
		<tr>
			<td valign=top><input type="radio" value="unix" <?=$a['unix'];?>name="os_group"></td>
			<td valign=top><?=$font;?>
				Unix systems (HP-UX, <br>
				SunOS, Solaris, IRIX, <br>
				Ultrix, Linux, BSD)
			</td>
		</tr>
		<tr>
			<td valign=top><input type="radio" value="misc" <?=$a['misc'];?>name="os_group"></td>
			<td valign=top><?=$font;?>
				Miscellanous (MacOS, <br>
				Novell, HP Printers, <br>
				Routers and Switches)
			</td>
		</tr>
		<tr>
			<td valign=top><input type="radio" value="unid" <?=$a['unid'];?>name="os_group"></td>
			<td valign=top><?=$font;?>Unidentified systems</td>
		</tr>
		<tr>
			<td valign=top><input id=other_os type="radio" value="other" <?=$a['other'];?>name="os_group"></td>
			<td valign=top nowrap><?=$font;?>
				Other: &nbsp;<input class=textbox type=text name="os_regex"
					size=9 value="<?=$os_regex;?>"
					onFocus="document.dbform.other_os.checked = true; return true;"><br>
				(case-sensitive regular <br>
				expression search)
			</td>
		</tr>
		</table>

	</td>

	<td width=20 nowrap style="border-right:solid 1px #dddddd;">&nbsp;</td>
	<td width=20 nowrap>&nbsp;</td>

	<td valign=top nowrap>

		<br>




		<!................................................................>

		<! Columns to Display >

		<?php

		function check_show_all()
		// if there isn't any field selected, then check the show all columns checkbox
		{
			// check all the 'show_XX' variables
			$all_cols = array('IP','Hostname','OS','Active','Total','PercentActive',
				'DateInserted','LastActive','LastModified','DaysOffline');

			foreach($all_cols as $v):
				$s = "show_$v";
				global $$s;
				if( $$s ) return '';	// don't check
			endforeach;

			// don't check it
			return 'checked ';
		}

		function show_checked($s)
		{
			// check for variable 'show_XX'
			$varname = "show_$s";
			global $$varname;
			if($$varname) return 'checked ';

			return '';	// not found
		}

		?>

		<?=head('Columns to Display');?>

		<?=$font;?>
		<input type=checkbox name=show_all_columns <?=check_show_all();?>
			onClick="check_show_all_columns();"> Show all columns<br>

		<input type=checkbox value=1 name=show_IP <?=show_checked('IP');?>
			onClick="uncheck_show_all_columns();"> IP address<br>

		<input type=checkbox value=1 name=show_Hostname <?=show_checked('Hostname');?>
			onClick="uncheck_show_all_columns();"> Hostname<br>

		<input type=checkbox value=1 name=show_OS <?=show_checked('OS');?>
			onClick="uncheck_show_all_columns();"> Operating system<br>

		<input type=checkbox value=1 name=show_Active <?=show_checked('Active');?>
			onClick="uncheck_show_all_columns();"> Activity count<br>

		<input type=checkbox value=1 name=show_Total <?=show_checked('Total');?>
			onClick="uncheck_show_all_columns();"> Total count<br>

		<input type=checkbox value=1 name=show_PercentActive <?=show_checked('PercentActive');?>
			onClick="uncheck_show_all_columns();"> Activity percentage<br>

		<input type=checkbox value=1 name=show_DateInserted <?=show_checked('DateInserted');?>
			onClick="uncheck_show_all_columns();"> Date inserted<br>

		<input type=checkbox value=1 name=show_LastActive <?=show_checked('LastActive');?>
			onClick="uncheck_show_all_columns();"> Date last active<br>

		<input type=checkbox value=1 name=show_LastModified <?=show_checked('LastModified');?>
			onClick="uncheck_show_all_columns();"> Date last modified<br>

		<input type=checkbox value=1 name=show_DaysOffline <?=show_checked('DaysOffline');?>
			onClick="uncheck_show_all_columns();"> No of days off-line<br>

		</font>





		<!................................................................>

		<br><?=head('Rows Per Page');?>

		<?=$font;?>
		Maximum no of rows to<br>
		display in each page:

		<table cellspacing=0 cellpadding=0>
		<tr>
			<td nowrap valign=center>
				&nbsp;<img src="images/tinybluebullet.gif">&nbsp;
			</td>
			<td nowrap valign=center>
				<input class=textbox type=text name=rows_per_page
					value="<?=$rows_per_page;?>" size=10>
			</td>
		</tr>
		</table>

		<br><br>

	</td>

	<td width=20 nowrap style="border-right:solid 1px #dddddd;">&nbsp;</td>
	<td width=20 nowrap>&nbsp;</td>

	<td valign=top nowrap>

		<br>

		<!................................................................>

		<?=head('Sort Data By');?>

		<?php $a = array($sort_field => 'checked '); ?>

		<?=$font;?>
		<input type="radio" name="sort_field" <?=$a['IP'];?>value="IP"> IP address<br>
		<input type="radio" name="sort_field" <?=$a['Hostname'];?>value="Hostname"> Hostname<br>
		<input type="radio" name="sort_field" <?=$a['OS'];?>value="OS"> OS name<br>
		<input type="radio" name="sort_field" <?=$a['PercentActive'];?>value="PercentActive"> Percent active<br>
		<input type="radio" name="sort_field" <?=$a['DateInserted'];?>value="DateInserted"> Date inserted<br>
		<input type="radio" name="sort_field" <?=$a['LastActive'];?>value="LastActive"> Date last active<br>
		<input type="radio" name="sort_field" <?=$a['DaysOffline'];?>value="DaysOffline"> Days off-line<br>
		</font>




		<!................................................................>

		<! Sort Order >

		<?php
		if( strcmp($sort_field,'desc') ) $sort_field='asc';
		$a = array($sort_field => 'checked ');
		?>

		<br> <?=head('Sort Order');?>

		<?=$font;?>
		<input type="radio" name="sort_order" <?=$a['asc'];?>value="asc"> Ascending<br>
		<input type="radio" name="sort_order" <?=$a['desc'];?>value="desc"> Descending<br>
		</font>

	</td>

</tr>
</table>











<! Submit and Reset >

<?php draw_hr(); ?>

<table>
<tr>
	<td width=30>&nbsp;</td>
	<td><?=draw_button('type="submit" value="Submit Form"');?></td>
	<td width=30>&nbsp;</td>
	<td><?=draw_button('type="reset" value="Reset Values"');?></td>

</tr>
</table>

</form>













</body>
</html>
